script ScriptBridge
    property parent : class "NSObject"

    property sValue: ""
    property nValue: 0

    to stringValue() -- () -> NSString (Text)
        return sValue
    end stringValue
    to setStringValue:newValue -- () -> NSString (Text)
        set sValue to newValue as text
    end setStringValue
    
    to numberValue() -- () -> NSNumber (Int, 0...100)
        return nValue
    end numberValue
    to setNumberValue:newValue -- () -> NSNumber (Int, 0...100)
        set nValue to newValue as integer
    end setNumberValue

    to doFunction_(param)
        return testMenu(param as text)
    end doFunctionA

    to doFunctionMultipleArgs___(args1, args2, args3)
        return args1 as text & args2 as text & args3 as text
    end doFunctionMultipleArgs___

    to getRecord_(params)
        return {|item1|: params's key1 as text, |item2|: params's key2 as text, |item3|: params's key3 as text}
    end getRecord

    -- internal test helper --
    
    on testMenu(param)
        set aData to {|menu|:¬
            {|id|:"file", value:"File", popup:¬
                {menuitem:[¬
                    {value:"New", onclick:"CreateNewDoc()"}, ¬
                    {value:"Open", onclick:"OpenDoc()"}, ¬
                    {value:"Close", onclick:"CloseDoc()"}]}}}
        return param  & ": " & Serialize(aData)
    end testSerialize

    on Serialize(theData)
        script theScript
            use framework "Foundation"
            property parent : a reference to current application
            property NSJSONWritingPrettyPrinted : a reference to 1
            on toJSON(theData)
                set theJSONData to parent's NSJSONSerialization's dataWithJSONObject:theData options:NSJSONWritingPrettyPrinted |error|:(missing value)
                set theString to (parent's NSString's alloc()'s initWithData:theJSONData encoding:(parent's NSUTF8StringEncoding)) as text
                return theString
            end toJSON
        end script
        return theScript's toJSON(theData)
    end Serialize

    on Deserialize(strJSON)
        script theScript
            use framework "Foundation"
            property parent : a reference to current application
            property NSJSONWritingPrettyPrinted : a reference to 1
            on fromJSON(strJSON)
                set {x, e} to parent's NSJSONSerialization's JSONObjectWithData:((parent's NSString's stringWithString:strJSON)'s dataUsingEncoding:(parent's NSUTF8StringEncoding)) options:0 |error|:(reference)
                if x is missing value then
                    error e's localizedDescription() as text
                else
                    return item 1 of ((parent's NSArray's arrayWithObject:x) as list)
                end if
            end fromJSON
        end script
        return theScript's fromJSON(strJSON)
    end Deserialize
end script
