//
//  ScriptBridge.swift
//  Swift-Storyboard
//
//  Created by Dirk Bunar on 28.10.20.
//

import Cocoa

@objc(NSObject) protocol ScriptBridge {
    
    // Important: ASOC does not bridge C primitives, only Cocoa classes and objects,
    // so Swift Bool/Int/Double values MUST be explicitly boxed/unboxed as NSNumber
    // when passing to/from AppleScript.
    
    var numberValue: NSNumber { get }
    var stringValue: NSString { get set }
 
    func doFunction(_: AnyObject) -> NSString
    func doFunctionMultipleArgs(_: NSString, _:NSString, _:NSString) -> NSString
    func getRecord(_: [String: AnyObject]) -> [NSString: AnyObject]?
}
